#ifndef PYRAJOYSTICK_H
#define PYRAJOYSTICK_H
#include "uinputdevice.h"
#include <map>

class PyraJoystick: public UinputDevice {
public:
	explicit PyraJoystick(std::string const& path, unsigned int bus, std::string const& name, unsigned int vendor, unsigned int product, unsigned int version, std::vector<PossibleEvent> const& possibleEvents, std::vector<AbsoluteAxisCalibrationData> const& absoluteAxesCalibrationData = std::vector<AbsoluteAxisCalibrationData>());
	virtual ~PyraJoystick();

	void rumble_handle();
	bool is_ready();
private:
	bool ready;
	int  _rumble;
	std::map<int, int> _effectMap;
	void deleteEffect(int id);
};

#endif
