#ifndef UINPUTDEVICE_H
#define UINPUTDEVICE_H

#include <linux/input.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <memory.h>
#include <linux/uinput.h>

#include <iostream>
#include <string>
#include <vector>

class UinputDevice
{
public:
  struct PossibleEvent
  {
    unsigned int type;
    std::vector<unsigned int> codes;
  };
  struct AbsoluteAxisCalibrationData {
    int axis;
    int min;
    int max;
    int fuzz;
    int flat;
  };
  explicit UinputDevice(std::string const& path, unsigned int bus, std::string const& name, unsigned int vendor, unsigned int product, unsigned int version, std::vector<PossibleEvent> const& possibleEvents, std::vector<AbsoluteAxisCalibrationData> const& absoluteAxesCalibrationData = std::vector<AbsoluteAxisCalibrationData>(), bool willRead = false);
  virtual ~UinputDevice();
  bool send(unsigned int type, unsigned int code, int value);
  bool ready() const; 
  operator bool() const; 
  void destroy();
protected:
  int _fd;
  void init(int effect_cnt, unsigned int bus, std::string const& name, unsigned int vendor, unsigned int product, unsigned int version, std::vector<PossibleEvent> const& possibleEvents, std::vector<AbsoluteAxisCalibrationData> const& absoluteAxesCalibrationData);
};
#endif
